function IQ_RPW_StatusChange(uid) {
    const block = 'list_status_'+uid;
    if(!document.getElementById(block)) {
        return false;
    }
	
    const v = +jQuery('#'+block).val();
	const data = {
		'action': 'admin_change_status',
		'Value': v,
		'UserID': uid,
	};
	jQuery.post(iq_rpw_unique.ajax_url, data, function(response) {
		if(response) {
			alert(response);
		}
	});
}

function IQ_RPW_WsStatusIndex(item) {
	if(item <= 0) { return false; }
	
	IQ_RPW_Loader(true);
	
	const data = {
		'action': 'admin_WsStatusIndex',
		'ItemID': item,
	};
	jQuery.post(iq_rpw_unique.ajax_url, data, function(response) {
		IQ_RPW_Loader(false);
		
		let phtml = jQuery.parseHTML( response );
		let result = jQuery(phtml).filter("#pop").length;
		if(result) {
			if(!document.getElementById('modal')) {
				jQuery(document.body).append('<div id="modal"></div>');
			}
			
			jQuery('#modal').html(response);
			setTimeout(function(){
				jQuery('#pop_modal').addClass('pop_show');
				PopOutClose();
			}, 100);
			return;
		}
		IQ_RPW_NoticeStrErr('notice_block', 'err', response);
	});
}

function IQ_RPW_WsStatusDo(pop, item) {
	pop = pop === undefined ? 0 : pop;
	item = item === undefined ? 0 : item;
	let pretag = '';
	if(pop) {
		pretag = 'pop_';
	}
	
	const block_form = pretag+'form_data';
	if(!document.getElementById(block_form)) {
		return;
	}
	
	if(!document.getElementById(pretag+'json_data') ||
	!document.getElementById(pretag+'sign_data')) {
		return;
	}
	const json_data = jQuery('#'+pretag+'json_data').val();
	const sign_data = jQuery('#'+pretag+'sign_data').val();
	
	let data = new FormData();
	data.append('action', 'admin_WsStatusDo');
	data.append('JsonData', json_data);
	data.append('SignData', sign_data);
	
	let FormValues = [];
	let value;
	jQuery('#'+block_form).find('select, input, textarea').each(function(){
		FormValues.push(this.id);
		if(jQuery(this).attr('type') == 'checkbox') {
			value = jQuery(this).is(':checked');
		} else {
			value = jQuery(this).val();
		}
		data.append( this.id, value );
	});
	data.append('Values', FormValues);
	data.append('Pop', pop);
	
	
	IQ_RPW_Loader(true);
	
	let ajax = new XMLHttpRequest();
	ajax.onload = ajax.onerror = function() {
		IQ_RPW_Loader(false);
		if(!document.getElementById(block_form)) {
			return;
		}
		
		const phtml = jQuery.parseHTML( this.responseText );
		if(this.status == 200) {
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				// success
				IQ_RPW_NoticeStrErr('notice_block', 'success', this.responseText);
				IQ_RPW_WsItemReload(item)
				PopClose();
				return true;
			}
		}
		
		const block_out = pretag+'notice_form_data';
		IQ_RPW_NoticeStrErr(block_out, 'err', this.responseText);
	}
	ajax.open("POST", iq_rpw_unique.ajax_url, true);
	ajax.send(data);
}

function IQ_RPW_WsItemReload(item) {
	if(item <= 0) {
		return false;
	}
	
	const block = 'item_block_'+item;
	if(!document.getElementById(block)) {
		return false;
	}
	jQuery('#'+block).css('opacity', 0.5);
	
	jQuery.ajax({
		type: "POST",
		url: iq_rpw_unique.ajax_url,
		data:{'action':'admin_WsItemReload',
		'ItemID':item},
		success: function(data) {
			if(!document.getElementById(block)) {
				return false;
			}
			
			if(data) {
				const el_temp = document.getElementById(block);
				el_temp.insertAdjacentHTML('afterEnd', data);
				el_temp.remove();
			}
		}
	});
}

function IQ_RPW_WsAdd(item) {
    item = item === undefined ? 0 : item;
	
	IQ_RPW_Loader(true);
	
	const data = {
		'action': 'admin_system_index',
		'ItemID': item,
	};
	jQuery.post(iq_rpw_unique.ajax_url, data, function(response) {
		IQ_RPW_Loader(false);
		
		let phtml = jQuery.parseHTML( response );
		let result = jQuery(phtml).filter("#pop").length;
		if(result) {
			if(!document.getElementById('modal')) {
				jQuery(document.body).append('<div id="modal"></div>');
			}
			
			jQuery('#modal').html(response);
			setTimeout(function(){
				jQuery('#pop_modal').addClass('pop_show');
				PopOutClose();
			}, 100);
			return;
		}
		IQ_RPW_NoticeStrErr('notice_block', 'err', response);
	});
}

function IQ_RPW_WsAddDo(pop) {
	pop = pop === undefined ? 0 : pop;
	let pretag = '';
	if(pop) {
		pretag = 'pop_';
	}
	
	let data = new FormData();
	data.append('action', 'admin_system_add_do');
	
	const block_form = pretag+'form_data';
	if(!document.getElementById(block_form)) {
		return;
	}
	
	if(!document.getElementById(pretag+'json_data') ||
	!document.getElementById(pretag+'sign_data')) {
		return;
	}
	const json_data = jQuery('#'+pretag+'json_data').val();
	const sign_data = jQuery('#'+pretag+'sign_data').val();
	data.append('JsonData', json_data);
	data.append('SignData', sign_data);
	
	let FormValues = [];
	let value;
	jQuery('#'+block_form).find('select, input, textarea').each(function(){
		FormValues.push(this.id);
		if(jQuery(this).attr('type') == 'checkbox') {
			value = jQuery(this).is(':checked');
		} else {
			value = jQuery(this).val();
		}
		data.append( this.id, value );
	});
	data.append('Values', FormValues);
	data.append('Pop', pop);
	
	IQ_RPW_Loader(true);
	
	let ajax = new XMLHttpRequest();
	ajax.onload = ajax.onerror = function() {
		IQ_RPW_Loader(false);
		if(!document.getElementById(block_form)) {
			return;
		}
		
		const phtml = jQuery.parseHTML( this.responseText );
		if(this.status == 200) {
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				// success
				IQ_RPW_SystemLoad();
				PopClose();
				return true;
			}
		}
		
		const block_out = pretag+'notice_form_data';
		IQ_RPW_NoticeStrErr(block_out, 'err', this.responseText);
	}
	ajax.open("POST", iq_rpw_unique.ajax_url, true);
	ajax.send(data);
}

function IQ_RPW_Loader(v) {
    v = v === undefined ? 1 : v;
	const block = 'loader_block';
	if(!document.getElementById(block)) {
		const el = document.body;
		el.insertAdjacentHTML('afterEnd', '<div id="loader_block"></div>');
	}
	if(v) {
		jQuery('#'+block).html('<div class="lds-roller"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>');
		jQuery(document.body).css('opacity', 0.5);
		jQuery(document.body).addClass('disabled');
	} else {
		jQuery('#'+block).text('');
		jQuery(document.body).css('opacity', 1);
		jQuery(document.body).removeClass('disabled');
	}
}

function IQ_RPW_SystemDelete(item) {
	if(item <= 0) {
		return false;
	}
	
	if(!confirm('Are you sure you want to delete')) {
		return false;
	}
	
	IQ_RPW_Loader(true);
	jQuery.ajax({
		type: "POST",
		url: iq_rpw_unique.ajax_url,
		data:{'action':'admin_system_delete',
		'ItemID':item},
		success: function(data) {
			IQ_RPW_Loader(false);
			
			let phtml = jQuery.parseHTML( data );
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				if(document.getElementById('ws_block_'+item)) {
					jQuery('#ws_block_'+item).fadeOut(200);
					setTimeout(function(){
						jQuery('#ws_block_'+item).remove();
					}, 200);
				}
				return true;
			}
			IQ_RPW_NoticeStrErr('notice_block', 'err', data);
		}
	});
}

function IQ_RPW_SystemLoad() {
	const block = 'ws_content';
	if(!document.getElementById(block)) {
		return false;
	}
	
	jQuery.ajax({
		type: "POST",
		url: iq_rpw_unique.ajax_url,
		data:{'action':'admin_systems_load'},
		success: function(data) {
			if(!document.getElementById(block)) {
				return false;
			}
			jQuery('#'+block).html(data);
		}
	});
}

function IQ_RPW_NoticeStrErr(block_out, type, msg) {
	if(!document.getElementById(block_out)) {
		return false;
	}
	if(!msg) {
		jQuery('#'+block_out).text('');
		return false;
	}
	
	let str = '';
	switch(type) {
		case 'err': {
			str = '<div class="iq_ref_alert_block iq_ref_err">'+msg+'</div>';
			break;
		}
		case 'success': {
			str = '<div class="iq_ref_alert_block iq_ref_ok">'+msg+'</div>';
			break;
		}
		case 'info': {
			str = '<div class="iq_ref_alert_block iq_ref_info">'+msg+'</div>';
			break;
		}
	}
	if(!str) {
		return false;
	}
	jQuery('#'+block_out).html(str);
}

function IQ_RPW_WsCodeUpdate(uid, c) {
    c = c === c ? 0 : c;
	if(uid <= 0) {
		return false;
	}
	
	if(!confirm('Are you sure you want to update the referral code for this partner?')) {
		return false;
	}
	
	IQ_RPW_Loader(1);
	
	jQuery.ajax({
		type: "POST",
		url: iq_rpw_unique.ajax_url,
		data:{'action':'admin_ref_code_update',
		'TargetID':uid,
		'Confirm':c},
		success: function(data) {
			IQ_RPW_Loader(0);
			
			let phtml = jQuery.parseHTML( data );
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				IQ_RPW_UserReload(uid);
				return true;
			}
		}
	});
}

function IQ_RPW_BalanceUpdate(uid) {
	IQ_RPW_Loader(true);
	jQuery.ajax({
		type: "POST",
		url: iq_rpw_unique.ajax_url,
		data:{'action':'admin_BalanceUpdate',
		'TargetID':uid},
		success: function(data) {
			IQ_RPW_Loader(false);
			
			let phtml = jQuery.parseHTML( data );
			let result = jQuery(phtml).filter("#pop").length;
			if(result) {
				if(!document.getElementById('modal')) {
					jQuery(document.body).append('<div id="modal"></div>');
				}
				
				jQuery('#modal').html(data);
				setTimeout(function(){
					jQuery('#pop_modal').addClass('pop_show');
					PopOutClose();
				}, 100);
				return;
			}
			IQ_RPW_NoticeStrErr('notice_block', 'err', data);
		}
	});
}

function IQ_RPW_BalanceUpdateDo(pop, uid) {
	pop = pop === undefined ? 0 : pop;
	uid = uid === undefined ? 0 : uid;
	let pretag = '';
	if(pop) {
		pretag = 'pop_';
	}
	
	let data = new FormData();
	data.append('action', 'admin_BalanceUpdateDo');
	
	const block_form = pretag+'form_data';
	if(!document.getElementById(block_form)) {
		return;
	}
	
	if(!document.getElementById(pretag+'json_data') ||
	!document.getElementById(pretag+'sign_data')) {
		return;
	}
	const json_data = jQuery('#'+pretag+'json_data').val();
	const sign_data = jQuery('#'+pretag+'sign_data').val();
	data.append('JsonData', json_data);
	data.append('SignData', sign_data);
	
	let FormValues = [];
	let value;
	jQuery('#'+block_form).find('select, input, textarea').each(function(){
		FormValues.push(this.id);
		if(jQuery(this).attr('type') == 'checkbox') {
			value = jQuery(this).is(':checked');
		} else {
			value = jQuery(this).val();
		}
		data.append( this.id, value );
	});
	data.append('Values', FormValues);
	data.append('Pop', pop);
	
	IQ_RPW_Loader(true);
	
	let ajax = new XMLHttpRequest();
	ajax.onload = ajax.onerror = function() {
		IQ_RPW_Loader(false);
		if(!document.getElementById(block_form)) {
			return;
		}
		
		const phtml = jQuery.parseHTML( this.responseText );
		if(this.status == 200) {
			let result = jQuery(phtml).filter("#success").length;
			if(result) {
				// success
				IQ_RPW_UserReload(uid);
				PopClose();
				return true;
			}
		}
		
		const block_out = pretag+'notice_form_data';
		IQ_RPW_NoticeStrErr(block_out, 'err', this.responseText);
	}
	ajax.open("POST", iq_rpw_unique.ajax_url, true);
	ajax.send(data);
}

function IQ_RPW_OnlyNumFloat(id) {
    var val = jQuery('#'+id).val();
    var val_new = val.replace(/[^0-9/.]/g, '').replace(/(\..*?)\..*/g, '$1');
    jQuery('#'+id).val(val_new);
}

function IQ_RPW_getAttr(param, defaultValue = 0) {
    location.search.substr(1)
        .split("&")
        .some(function(item) { // returns first occurence and stops
            return item.split("=")[0] == param && (defaultValue = item.split("=")[1], true)
        })
    return defaultValue
}

function IQ_RPW_setAttr(key, value) {
	var baseUrl = [location.protocol, '//', location.host, location.pathname].join(''),
		urlQueryString = document.location.search,
		newParam = key + '=' + value,
		params = '?' + newParam;
    if (urlQueryString) {
        var updateRegex = new RegExp('([\?&])' + key + '[^&]*');
        var removeRegex = new RegExp('([\?&])' + key + '=[^&;]+[&;]?');
        if( typeof value == 'undefined' || value == null || value == '' ) {
            params = urlQueryString.replace(removeRegex, "$1");
            params = params.replace( /[&;]$/, "" );
        } else if (urlQueryString.match(updateRegex) !== null) {
            params = urlQueryString.replace(updateRegex, "$1" + newParam);
        } else {
            params = urlQueryString + '&' + newParam;
        }
    } else {
		if( typeof value == 'undefined' || value == null || value == '' )
			return true;
	}
    params = params == '?' ? '' : params;
    window.history.replaceState({}, "", baseUrl + params);
	return true;
};

function IQ_RPW_sort(v) {
	IQ_RPW_setAttr('sort', v);
	
	let order = IQ_RPW_getAttr('order');
	if(order == 'DESC') {
		order = 'ASC';
	} else {
		order = 'DESC';
	}
	IQ_RPW_setAttr('order', order);
	location.reload();
}

function IQ_RPW_UserReload(item) {
	if(item <= 0) {
		return false;
	}
	
	const block = 'uid_block_'+item;
	if(!document.getElementById(block)) {
		return false;
	}
	jQuery('#'+block).css('opacity', 0.5);
	
	jQuery.ajax({
		type: "POST",
		url: iq_rpw_unique.ajax_url,
		data:{'action':'admin_user_reload',
		'ItemID':item},
		success: function(data) {
			if(!document.getElementById(block)) {
				return false;
			}
			
			if(data) {
				const el_temp = document.getElementById(block);
				el_temp.insertAdjacentHTML('afterEnd', data);
				el_temp.remove();
			}
		}
	});
}